
#include "glob.h"
#include "rtc.h"
#include "config.h"


#include "Wire.h"
#define DS1307_ADDRESS 0x68
byte zero = 0x00; //workaround for issue #527



void rtcSetup(){

 Wire.begin();
}

void getRTCDateTime(){

  Wire.beginTransmission(DS1307_ADDRESS);
  Wire.send(zero);
  Wire.endTransmission();
  Wire.requestFrom(DS1307_ADDRESS, 7);

if(RTC_ERROR_FLAG==0)
{
  //Serial.println("RTC IS ACTIVE :\n");
  s = bcdToDec(Wire.receive());
  m = bcdToDec(Wire.receive());
  h = bcdToDec(Wire.receive() & 0b111111); //24 hour time
  wkDay = bcdToDec(Wire.receive()); //0-6 -> sunday - Saturday
  dd = bcdToDec(Wire.receive());
  mm = bcdToDec(Wire.receive());
  yy = CENTURY + bcdToDec(Wire.receive());
  latitude = DEFAULT_LATITUDE;
  longitude = DEFAULT_LONGITUDE;
}
}

void setRTCDateTime()
{
  
  /*subtract 5 hour 30 min to currect the time*/
  
  byte s= 45; //0-59
  byte m  =26; //0-59
  byte h= 9; //0-23
  byte wkDay =2; //1-7
  byte dd =11; //1-31
  byte mm = 12; //1-12
  byte yy  = 13; //0-99

  Wire.beginTransmission(DS1307_ADDRESS);
  Wire.send(zero); //stop Oscillator

  Wire.send(decToBcd(s));
  Wire.send(decToBcd(m));
  Wire.send(decToBcd(h));
  Wire.send(decToBcd(wkDay));
  Wire.send(decToBcd(mm));
  Wire.send(decToBcd(dd));
  Wire.send(decToBcd(yy));
  Wire.send(zero); //start
  Wire.endTransmission(); 
  
}



void rtcSyncWithGPSImmediate(){
  rtcsend();
  Serial.println("Called rtcImmediateSync");

}

void rtcSyncWithGPS(){
  static int rtc_counter=0;
  if(rtc_counter > RTC_SYNC_CNT_LIM){
    rtc_counter=0;
    if(gps_locked){
      rtcsend();
      Serial.println("RTC sync regular complete");
    }

  }

  rtc_counter++;
}

void rtcsend(){

  Wire.beginTransmission(DS1307_ADDRESS);
  Wire.send(zero); //stop Oscillator

  Wire.send(decToBcd(s));
  Wire.send(decToBcd(m));
  Wire.send(decToBcd(h));
  Wire.send(decToBcd(wkDay));
  Wire.send(decToBcd(dd));
  Wire.send(decToBcd(mm));
  Wire.send(decToBcd(getLastTwoDigOfYear(yy)));

  Wire.send(zero); //start

  Wire.endTransmission();


}

byte decToBcd(byte val){
  // Convert normal decimal numbers to binary coded decimal
  return ( (val/10*16) + (val%10) );
}

byte bcdToDec(byte val)  {
  // Convert binary coded decimal to normal decimal numbers
  return ( (val/16*10) + (val%16) );
}

int getLastTwoDigOfYear(int y){
 return(y%1000); 
}


int Check_RTC()
 {
  Wire.beginTransmission(DS1307_ADDRESS);
  Wire.send(zero);
  Wire.endTransmission();
  Wire.requestFrom(DS1307_ADDRESS, 7);
  if(Wire.available()>0)
   {
     //Serial.println("RTC:GOOD");
     RTC_ERROR_FLAG=0;
    
    // Serial.println(RTC_ERROR_FLAG);
     return(RTC_ERROR_FLAG);
   }else
   {
     //Serial.println ("RTC:BAD");
     RTC_ERROR_FLAG=1;
     //Serial.println(RTC_ERROR_FLAG);
     return(RTC_ERROR_FLAG);
   }
}



